"""Class Domain - 1D domains for finite-volume computations of
   the shallow water wave equation


   Copyright 2004
   Ole Nielsen, Stephen Roberts, Duncan Gray, Christopher Zoppou
   Geoscience Australia
"""

class Domain:

    def __init__(self, coordinates):
        """
        Build 1D elements from x coordinates
        """

        from Numeric import array, zeros, Float, Int
        
        #Store Points
        self.coordinates = array(coordinates)

        #Register number of Elements
        self.number_of_elements = N = len(self.coordinates)-1
        

        #Allocate space for geometric quantities
        self.edge_coordinates = zeros((N, 2), Float)
        self.centroids = zeros(N, Float)
        self.areas = zeros(N, Float)
        for i in range(N):
            xl = self.coordinates[i]
            xr = self.coordinates[i+1]
            self.edge_coordinates[i,0] = xl
            self.edge_coordinates[i,1] = xr
            
            centroid = (xl+xr)/2
            self.centroids[i] = centroid

            msg = 'Coordinates should be ordered, smallest to largest'
            assert xr>xl, msg
            self.areas[i] = (xr-xl)



        print 'N', N
        print 'Coordinates', self.coordinates
        print 'Centroid', self.centroids
        print 'Areas', self.areas
        print 'Edge_Coordinates', self.edge_coordinates
        
        
    def get_centroids()

if __name__ == "__main__":
    points1 = [0.0, 1.0, 2.0, 3.0]
    D1 = Domain(points1)

    points2 = [0.0, 1.0, 2.0, 3.0, 2.5]
    D2 = Domain(points2)





