#!/usr/bin/env python

import unittest
from math import sqrt

from domain import *
from Numeric import allclose, array


class TestCase(unittest.TestCase):
    def setUp(self):
        pass

        
    def tearDown(self):
        pass

    def test_construct(self):
        a = 0.0
        b = 2.0
        c = 2.5
        d = 3.0
        e = 10.0
        f = 12.0

        points = [a, b, c, d, e, f]

        domain = Domain(points)

        centroids = domain.get_centroids()
        assert allclose(centroids, [1.0, 2.25, 2.75, 6.5, 11.0])
            
    def test_in_order(self):
        a = 0.0
        b = 2.0
        c = 2.5
        d = 3.0
        e = 10.0
        f = 12.0

        points = [a, c, b, d, e, f]

        try:
            domain = Domain(points)
        except:
            pass
        else:
            msg = 'Should have raised exception'
            raise msg
        
        
        
#-------------------------------------------------------------
if __name__ == "__main__":
    suite = unittest.makeSuite(TestCase,'test')
    runner = unittest.TextTestRunner()
    runner.run(suite)
